-- LINDA LUA ACTIVATION AND SETUP
-- Updated for LINDA 3.0.4
-- Oct 2017

-- #################################################### --
-- !!! NO USER SETTINGS IN THIS FILE  - DO NOT EDIT !!! --
-- #################################################### --

-- #################################################### --
-- !!! NO USER SETTINGS IN THIS FILE  - DO NOT EDIT !!! --
-- #################################################### --

-- #################################################### --
-- !!! NO USER SETTINGS IN THIS FILE  - DO NOT EDIT !!! --
-- #################################################### --

-- #################################################### --
-- !!! NO USER SETTINGS IN THIS FILE  - DO NOT EDIT !!! --
-- #################################################### --

----------------------------------------------------------------------

RESTART = 1
NEWAC = 0
RESTART_TIMER = ipc.elapsedtime()
ACNAME = ""
unloop = 0

ipc.set("RESTART", RESTART)

-- errors
function _err (s)
	ipc.display(s, 8)
	ipc.log("LINDA:: ---> ERROR:: " .. s)
end

-- debug level 1 - standard
function _log (s)
	if ipc.get("DEBUG") > 0 then ipc.log("LINDA:: " .. s) end
end

-- debug level 2 - detailed
function _logg (s)
	if ipc.get("DEBUG") > 1 then ipc.log("LINDA:: " .. s) end
end

-- debug level 3 - verbose
function _loggg (s)
	if ipc.get("DEBUG") > 2 then ipc.log("LINDA:: " .. s) end
end

-- debug level 4 - DEBUG
function _logggg (s)
	if ipc.get("DEBUG") > 3 then ipc.log("LINDA:: " .. s) end
end

-- check file exist
function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end

---------------------------------------------------------------------

-- read aircrafts
function read_aircrafts ()
    _loggg('[START] Reading Available Aircraft Modules')

    pathname = ipc.readSTR('3E00', 255)
    x = string.len(pathname)
    s = ""
    i = 0
    while i < x and s ~= '\0' do
        i = i + 1
        s = string.sub(pathname, i, i)
    end
    pathname = string.sub(pathname, 1, i - 1)
    acPath = "modules/linda/aircrafts/"
    --_loggg('[START] pathname = "' .. pathname .. '" ' .. acPath)
    pathname = string.format("%s%s", pathname, acPath)
    _loggg('[START] pathname = "' .. pathname .. '"')

    --RESTART_TIMER = ipc.elapsedtime()
    dir = nil
    --while (dir == nil) and (RESTART_TIMER + 3000 > ipc.elapsedtime()) do
	   dir_obj = lfs.dir (pathname) --'.\\modules\\linda\\aircrafts\\')
	   dir = dir_obj ()
    --end

    if dir == nil then
        _loggg('[START] Error reading available aircraft modules')
    else
        while dir ~= nil do
            simfolder = ''
            ident = ipc.get("PATH_ACFT") .. dir .. "/ident.lua"
            _logggg('[START] Ident = ' .. dir .. "/ident.lua")
            if file_exists(ident) then
                _logg("[START] Aircraft found: " .. dir)
                dofile (ident)
                ACFT[simfolder] = dir
            end
            dir = dir_obj ()
        end
    end

    RESTART = 0
    ipc.set("RESTART", RESTART)

    _loggg('[START] Reading Available Aircraft Modules completed')
end

---------------------------------------------------------------------

-- read libs
function read_libs ()
    _loggg('[START] Reading Library Modules')

    pathname = ipc.readSTR('3E00', 255)
    x = string.len(pathname)
    s = ""
    i = 0
    while i < x and s ~= '\0' do
        i = i + 1
        s = string.sub(pathname, i, i)
    end
    pathname = string.sub(pathname, 1, i - 1)
    acPath = "modules/linda/libs/"
    --_loggg('[START] pathname = "' .. pathname .. '" ' .. acPath)
    pathname = string.format("%s%s", pathname, acPath)
    _loggg('[START] pathname = "' .. pathname .. '"')

	local libreq = ""
	local i = 0

    --RESTART_TIMER = ipc.elapsedtime()
    dir = nil

    --while (dir == nil) and (RESTART_TIMER + 3000 > ipc.elapsedtime()) do
	   dir_obj = lfs.dir (pathname) --'.\\modules\\linda\\libs\\')
	   dir = dir_obj ()
    --end

    if dir == nil then
        _loggg('[START] Error reading library modules')
    else
        while dir ~= nil do
            if string.find(dir, 'lib-') ~= nil then
                lib = ipc.get("PATH_LIB") .. dir
                _logg("[START] Library found: " .. dir)
                LIBS[i] = string.sub(dir,1,-5)
                i = i + 1
            end
            dir = dir_obj ()
        end

        -- load libraries
        for id, file in pairs(LIBS) do
            libreq = libreq .. ipc.get("PATH_LIB") .. file .. "#"
            --_loggg('[START] LibReq = ' .. libreq)
        end
    end

	ipc.set("LIBREQ", libreq)
    _loggg('[START] Reading Library Modules completed')
end

---------------------------------------------------------------------------------
-- Detect aircraft
function Start()
local sim = 0
local path
    _loggg('[START] Detecting Aircraft')
    --ACFT = {["FSX Default"] = "FSX Default"}
    read_aircrafts()
    read_libs()

    RESTART = 1
    ipc.set("RESTART", RESTART)

    ipc.set("acft_handle", "FSX Default")
	acft = ipc.readSTR(0x3D00, 35)
    ACNAME = acft
	airfile = ipc.readSTR(0x3C00, 255)
    _log("[START] *************************************************************")
	_log("[START] Current Aircraft: " .. acft)
	_logg("[START] Air file: " .. airfile)

    _loggg('[START] searching available aircraft modules..');

	for s, h in pairs(ACFT) do
		if string.find(airfile:upper(), s:upper(), 0, true) then
			ipc.set("acft_handle", h)
            _loggg('[START] *** module found ****************************'
                .. '****************')
		end

        _loggg('[START] s = ' .. s:upper() )
        _loggg('[START] h = ' .. h )

		if string.find(airfile:upper(), s:upper(), 0, true) then
			ipc.set("acft_handle", h)
            _loggg('[START] *** module found ****************************'
                .. '****************')
		end
 	end

	if ipc.get("acft_handle") == 1 then
		unloop = unloop + 1
		if unloop < 4 then
            _loggg('[START] Waiting for Aircraft Handle - retrying')
			Start()
		else
			_err("[START] Something is very wrong with aircraft detection!")
			return
		end
	end

    _log("[START] *************************************************************")
    _log("[START] Aircraft module detected: " .. ipc.get("acft_handle"))
    _log("[START] *************************************************************")

    path = ipc.get("PATH_SYS") .. "init"
    _log('[START] Calling Initialisation...')
    _loggg('[START] Path = ' .. path)

    if file_exists(path .. '.lua') then
        ipc.runlua(path .. '.lua')
    else
        _log('[START] Unable to find INIT.LUA - Try Restarting')
    end

    RESTART = 0
    ipc.set("RESTART", RESTART)

    _loggg('[START] Detecting Aircraft completed')
end

----------------------------------------------------------------------

function onFltLoad ()
	_loggg("[START] Flight Load event caught!")
	_log("[START] *************************************************************")
	_log("[START] New Flight Load - restarting...")
	Start()
end

----------------------------------------------------------------------

function onPlaneSet ()
    if ACNAME ~= ipc.readSTR(0x3D00, 35) then
	   _loggg("[START] Airplane Set event caught!")
        _log("[START] *************************************************************")
        _log("[START] New Aircraft Selected - restarting...")
	   Start()
    else
        _loggg('[START] Airplane event for same aircraft - exit')
    end
end

----------------------------------------------------------------------

function paramHandler(param)
    _log('[START] param ' .. param)
end

----------------------------------------------------------------------

-- main code starts here --------

-- Starting
ipc.log("[START] *********************** STARTING LINDA ***********************")

-- System paths
ipc.set("PATH_LIB", "linda/libs/")
ipc.set("PATH_ACFT", "linda/aircrafts/")
ipc.set("PATH_SYS", "linda/system/")
ipc.set("PATH_ACFT_CFG", "linda-cfg/aircrafts/")
ipc.set("PATH_SYS_CFG", "linda-cfg/system/")

-- set default flags
ipc.set("HID_ENABLED", 0)
ipc.set("VRI_ENABLED", 0)
ipc.set("VRI_DELAY", 10000)
ipc.set("GLOBAL", 0)
ipc.set("RUNAWAY", 0)
ipc.set("HID_READY", 0)
ipc.set("DEBUG", 0)
ipc.set("SAITEK", 0)
ipc.set("VAS_DISPLAY", 0)

-- not a mapper
MAPPER = false
ACFT = {["FSX Default"] = "FSX Default"}
LIBS = {}
CFG = {}
VRI = {}
HID = {}

JSTK={}
JSTKrp={}
JSTKrl={}

JSTK2={}
JSTK2rp={}
JSTK2rl={}

JSTK3={}
JSTK3rp={}
JSTK3rl={}

-------------------------------------------------------------------------------

ipc.log('LINDA:: [START] Loading System Configuration files')

config = ipc.get("PATH_SYS_CFG") .. "config-sys"
if file_exists(config .. ".lua") then
    require(config)
    ipc.set("GLOBAL", CFG["GLOBAL"])
    ipc.set("DEBUG", CFG["DEBUG"])
    ipc.set("SAITEK", CFG["SAITEK"])
    ipc.set("VAS_DISPLAY", CFG["VAS"])
    ipc.set("RUNAWAY", CFG["RUNAWAY"])
else
    _err ("[START] Main system config not found! Run GUI and check configs!")
    return
end

if ipc.get("DEBUG") == 0 then
    ipc.log("LINDA:: *********************************************************************")
    ipc.log("LINDA:: [START] WARNING - All LUA logging switched off !!!")
    ipc.log("LINDA:: [START] Go to Setup LINDA to switch on (if required)")
    ipc.log("LINDA:: *********************************************************************")
end

-- read HID configuration in system/config-hid.lua
config = ipc.get("PATH_SYS_CFG") .. "config-hid"
if file_exists(config .. ".lua") then
	require(config)
	ipc.set("HID_ENABLED", 1)
	ipc.set("HID_READY", 1)
else
	ipc.set("HID_ENABLED", 0)
	_err("[START] HID devices config not found. Joysticks disabled!")
	ipc.sleep(3000);
end

-- read MCP Combo configuration in system/config-vri.lua
config = ipc.get("PATH_SYS_CFG") .. "config-vri"
if file_exists(config .. ".lua") then
    local VRIEnabled, VRIType, VRIPort, VRIDelay
    require(config)
    VRIEnabled = VRI["ENABLED"]
    VRIType = VRI["TYPE"]
    VRIPort = VRI["COMPORT"]
    VRIDelay = VRI["DELAY"]
    if VRIEnabled == nil then VRIEnabled = 0 end
    if VRIType == nil then VRIType = 2 end
    if VRIPort == nil then VRIPort = 0 end
    if VRIDelay == nil then VRIDelay = 30 end
	ipc.set("VRI_ENABLED", VRIEnabled)
    ipc.set("VRI_DEVICE", "com" .. tostring(VRIPort))
    ipc.set("VRI_DELAY", tonumber(VRIDelay) * 1000)

	-- test for VR type end
    if VRIType == 1 then
        ipc.set("VRI_TYPE", "mcp")
    elseif VRIType == 2 then
        ipc.set("VRI_TYPE", "mcp2")
    elseif VRIType == 3 then
        ipc.set("VRI_TYPE", "mcp2a")
    else
        ipc.set("VRI_TYPE", "mcp2")
    end

    _log("[START] VRInsight MCP Set = " .. tostring(ipc.get("VRI_TYPE")))
    _loggg('[START] VRI: Enabled=' .. tostring(ipc.get(VRI_ENABLED)) ..
        ' COMPort=' .. tostring(ipc.get("VRI_DEVICE") ..
        ' Delay=' .. tostring(ipc.get("VRI_DELAY"))))
else
    ipc.set("VRI_ENABLED", 0)
    _err ("[START] VRInsight config not found! MCP Combo disabled!")
    ipc.sleep(3000);
end

if (ipc.get("VRI_ENABLED") == 0) and (ipc.get("HID_ENABLED") == 0)
then
	_err ("[START] All hardware modules disabled... Exiting!")
	return
end

-------------------------------------------------------------------------------

-- Reading aircrafts folder for modules installed
read_aircrafts ()

-- Reading _includes folder for libraries
read_libs ()

unloop = 0

------------------------------------------------------------------------

ipc.log('LINDA:: [START] System Configuration files loaded')

------------------------------------------------------------------------------

while ((START == 1) and (ipc.elapsedtime() - TIMER < 1000)) do
   _loggg('[START] waiting for start to complete...')
end

START = 0

ipc.sleep(1000)

-- set up restart events
event.offset(0x3D00, "STR", 99, "onPlaneSet")    -- new aircraft loaded
--event.offset(0x32FC, "UW", "onPlaneSet")
event.sim(FLIGHTLOAD, "onFltLoad")               -- new scenerio loaded
event.param('paramHandler')

-------------------------------------------------------------------------------
